#include "draw_world.h"

using namespace std;

CDraw_World::CDraw_World(const string& file_, const SDL_Rect& coord_, const float& coef_resol_) : dest(coord_), CDraw(file_, coord_, coef_resol_) {
}

void CDraw_World::show(const SDL_Rect& d, const int& offset, const float& deep) {

   dest = d;
   dest.x -= offset;

   // texture's id
   unsigned id_text = (unsigned)round(dest.x / SIZE_TEXTURE_W_MAX);

   float gl_x = ((float)dest.x - (float)(id_text * SIZE_TEXTURE_W_MAX)) * coef_resol;
   float gl_y = (float)dest.y * coef_resol;
   float gl_w = SIZE_TEXTURE_W_MAX * coef_resol;
   float gl_h = (float)object_properties().h * coef_resol;

   float j = 0;

   // we show two zone-textures from all ground or sky 
   for(int i = id_text; i < nbr_textures && i < id_text + 2; ++i) {

   //  Bind the texture object
      glBindTexture( GL_TEXTURE_2D, texture[i] );
      glPushMatrix();

      glBegin(GL_QUADS);
      glTexCoord2i(0,1);
      glVertex3i(-gl_x + j, gl_y,-1);
      glTexCoord2i(1,1);
      glVertex3i(-gl_x + gl_w + j, gl_y,-1);
      glTexCoord2i(1,0);
      glVertex3i(-gl_x + gl_w + j, gl_y + gl_h,-1);
      glTexCoord2i(0,0);
      glVertex3i(-gl_x + j, gl_y + gl_h,-1);
      glEnd();

      glPopMatrix();

      //go on the next zone-texture;
      j += gl_w;
   }
}

