#include "init_datasworld.h"

using namespace std;

void init_datas_world(s_game &game, const string& file_music, const string& file_sky, vector<string>& file_ground) {

   game.clock = CLOCK_TIME;
   game.clock_ticks = CLOCK_TICKS;

   try {
      game.sounds = new CSounds(7);
      game.sounds->load_music(file_music);
      game.sounds->load_sound(SOUNDS_PATH + "jump.wav");
      game.sounds->load_sound(SOUNDS_PATH + "pickup.wav");
      game.sounds->load_sound(SOUNDS_PATH + "death.wav");
      game.sounds->load_sound(SOUNDS_PATH + "fire.wav");
      game.sounds->load_sound(SOUNDS_PATH + "enemy_death.wav");
      game.sounds->load_sound(SOUNDS_PATH + "level.wav");
   }
   catch(string &caught) {
      cerr << "init_datasworld.cpp : Can't load sounds." << endl;
      delete game.sounds;
      exit_game(game);
   }

   // We draw earth and sky
   try {

      // We load sky picture
      game.ODrawW_sky = new CDraw_World(file_sky, game.rect_sky, game.coef_resol);
      // only texture is saved, not surface because we don't use tests on surface
      game.ODrawW_sky->Free_surface();
      // We load earth picture
      for(vector<string>::iterator i = file_ground.begin(); i != file_ground.end(); ++i) {
         shared_ptr<CDraw_World> draw_ground = make_shared<CDraw_World>(*i, game.rect_earth, game.coef_resol);
         // only texture is saved, not surface because we don't use tests on surface
         draw_ground->Free_surface();
         game.VDrawW_ground.push_back(draw_ground);
      }

   }
   catch(string &caught) {
      cerr << "init_datasworld.cpp : Can't load earth and sky." << endl;
      exit_game(game);
   }

}
